/* Randdemo.prg
   Demonstrates the randomgen-function
   Needs xBase Tools III
   xpp randdemo /q/ w
   alink randdemo
   Written by: Chris van Reeven */

#pragma Library("xbtbase1.lib")
#pragma Library("xbtbase2.lib")


PROCEDURE MAIN()
LOCAL i, np := sqrt( (0.5+rand(0)) ), cTxt

cTxt := "random"+ substr(TIME(),7,2)
SET ALTERNATE TO (cTxt)
SET ALTERNATE ON

// Generate 100 values with the unique <np>-seed
For i := 1 TO 100
  ?STR(RANDOMGEN( np ),15,10)
NEXT

SET ALTERNATE OFF
SET ALTERNATE TO

RETURN

************************************************************************  
FUNCTION RANDOMGEN(np)
**********************
/* The function RANDOMGEN(np) needs
   as incoming parameter <np> a for each
   range of figures once generated
   startvalue <np> which is formed by
   np := sqrt( (0.5+rand(0)) ) */

LOCAL n, nq

n := rand()
nq := n*np
nq := IF(nq>1, 1-(nq-1), nq)

RETURN nq
  

